package id.co.hanoman.ngdemo;

import javax.annotation.PostConstruct;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Profile;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Component;

import com.senomas.common.FileDataLoader;
import com.senomas.common.U;

@Component
@Profile("init-data")
public class InitData extends FileDataLoader {
	private final static Logger log = LoggerFactory.getLogger(InitData.class);
	
	@Autowired
	MongoTemplate mongoTemplate;
	
	@PostConstruct
	protected void populate() throws Exception {
		log.info("Populate data");
		loadData(getClass().getClassLoader().getResource("data-init").openConnection());
	}
	
	@Override
	protected void save(Object obj) {
		log.info("SAVE "+U.dump(obj));
		mongoTemplate.save(obj);
	}
	
	@Override
	protected Object find(Class<?> cl, String key, Object data) {
		Query qry = new Query();
		qry.addCriteria(Criteria.where(key).is(data));
		return mongoTemplate.findOne(qry, cl);
	}
}
