package id.co.hanoman.ngdemo;

import java.util.LinkedList;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.senomas.boot.security.domain.SecurityRole;
import com.senomas.boot.security.domain.SecurityUser;
import com.senomas.boot.security.service.UserService;

import id.co.hanoman.ngdemo.domain.AppRole;
import id.co.hanoman.ngdemo.domain.AppUser;
import id.co.hanoman.ngdemo.domain.AppUserRepository;

@Component
public class UserServiceImpl implements UserService {
	private static final Logger log = LoggerFactory.getLogger(UserServiceImpl.class);
	
	@Autowired
	AppUserRepository userRepo;
	
	@Override
	public SecurityUser findByLogin(String login) {
		if (log.isDebugEnabled()) log.debug("findByLogin("+login+")");
		try {
			return userRepo.findOne(login);
		} catch (RuntimeException e) {
			log.error("ERROR "+e.getMessage(), e);
			return null;
		}
	}

	@Override
	public List<SecurityRole> getRoles(SecurityUser user) {
		List<SecurityRole> roles = new LinkedList<>();
		for (AppRole r : ((AppUser) user).getRoles()) {
			roles.add(r);
		}
		return roles;
	}

	@Override
	public SecurityUser save(SecurityUser user) {
		return userRepo.save((AppUser) user);
	}

}
